diff --git a/cluster_library.c b/cluster_library.c
index 767e95b0ae..fc49e1275a 100644
--- a/cluster_library.c
+++ b/cluster_library.c
@@ -892,8 +892,8 @@ cluster_free(redisCluster *c, int free_ctx)
     if (c->cache_key) {
         if (c->redirections) {
             zend_hash_del(&EG(persistent_list), c->cache_key);
+            c->cache_key = NULL;
         }
-        zend_string_release(c->cache_key);
     }
 
     /* Free structure itself */
diff --git a/redis.c b/redis.c
index b087ac4427..504fcdaf4d 100644
--- a/redis.c
+++ b/redis.c
@@ -559,8 +559,10 @@ free_reply_callbacks(RedisSock *redis_sock)
 
 /* Passthru for destroying cluster cache */
 static void cluster_cache_dtor(zend_resource *rsrc) {
-    redisCachedCluster *rcc = (redisCachedCluster*)rsrc->ptr;
-    cluster_cache_free(rcc);
+    if (rsrc->ptr) {
+        redisCachedCluster *rcc = (redisCachedCluster*)rsrc->ptr;
+        cluster_cache_free(rcc);
+    }
 }
 
 void
